/*
isrt.c Version 0.2.0 - Insert node in tree
Copyright (C) 2002-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include "tree.h"

int isrt(new,curr,id,round,court,type)
prfmt *new;
prfmt *curr;
int id;
int round;
int court;
int type;
   {
   /* unique:    RC = 1 */
   /* duplicate: abort */
   int rslt;
   while (1)
      {
      rslt = strcmp(new->pair,curr->pair);
      if (rslt < 0)
         {
         if (curr->left == NULL)
            {
            curr->left = new;
            return(1);
            } /* insert left */
         else
            {
            curr = curr->left;
            } /* descend left */
         } /* if left */
      else if (rslt > 0)
         {
         if (curr->right == NULL)
            {
            curr->right = new;
            return(1);
            } /* insert right */
         else
            {
            curr = curr->right;
            } /* descend right */
         } /* if right */
      else
         {
         fprintf(stderr,"Id %d Round %d "
            "Court %d Type %d\n",
            id, round, court, type);
         fprintf(stderr,"Duplicate insert %s\n",
            new->pair);
         exit(1); /* duplicate */
         }
      } /* descent */
   } /* isrt */
